//
//  ObjCQueue.m
//  Bug Test
//
//  Created by Eric on 8/15/14.
//  Copyright (c) 2014 erflink. All rights reserved.
//

#import <Foundation/Foundation.h>
#include "ObjcQueue.h"

// Need a global (static) lock to lock accesses to a global structure
// from each instance of the object
NSMutableArray *qArray;

/// No "NSQueue" in Objective-C, so create our own
@implementation ObjCQueue
{
    
}

+ (void) init
{
    qArray =  [[NSMutableArray alloc] init]; 
    //   NSLog(@"(init)qArray class is: %@\n", NSStringFromClass([qArray class]));
}

/// Since we're using an array for a queue, we use the convention that we push (add)
/// an object at the end of the array (since that's were addObject will put it by default)
/// and pop off the top of the array
+ (void) push:(NSString *)calEvent
{
    //    NSLog(@"(push)qArray class is: %@\n", NSStringFromClass([qArray class]));
    [qArray addObject:calEvent];
} 

+ (NSString *) pop
{
    // This will return nil if there's no first object
    NSString *retEvent = [qArray objectAtIndex:0];
    // Don't delete the front of the queue if nothing is there
    if (retEvent != nil)
        [qArray removeObjectAtIndex:0];
    
    return retEvent;
}


@end
